bits 32

section .data
align 32
_shiftcount:
    db 31, 31, 31, 31, 31, 31, 31, 31
    db 30, 30, 30, 30, 29, 29, 29, 29
    db 28, 28, 28, 28, 27, 27, 27, 27
    db 26, 26, 26, 26, 25, 25, 25, 25
_extrabits:
    db 0, 0, 0, 0, 0, 0, 0, 0
    db 1, 1, 1, 1, 2, 2, 2, 2
    db 3, 3, 3, 3, 4, 4, 4, 4
    db 5, 5, 5, 5, 6, 6, 6, 6
_lengthoffset:
    dd 3, 4, 5, 6, 7, 8, 9, 10
    dd 11, 13, 15, 17, 19, 23, 27, 31
    dd 35, 43, 51, 59, 67, 83, 99, 115
    dd 131, 163, 195, 227, 259, 323, 387, 451
_shiftcount_lengths:
    db 31, 31, 31, 31, 30, 30, 29, 29
    db 28, 28, 27, 27, 26, 26, 25, 25
    db 24, 24, 23, 23, 22, 22, 21, 21
    db 20, 20, 19, 19, 18, 18, 17, 17
_extrabits_lengths:
    db 0, 0, 0, 0, 1, 1, 2, 2
    db 3, 3, 4, 4, 5, 5, 6, 6
    db 7, 7, 8, 8, 9, 9, 10, 10
    db 11, 11, 12, 12, 13, 13, 14, 14
_distoffset:
    dd 1, 2, 3, 4, 5, 7, 9, 13
    dd 17, 25, 33, 49, 65, 97, 129, 193
    dd 257, 385, 513, 769, 1025, 1537, 2049, 3073
    dd 4097, 6145, 8193, 12289, 16385, 24577, 32769, 49153

section .bss
global _mBsrCodeTable
_mBsrCodeTable: resb 1024 * 4
global _mBsrLenTable
_mBsrLenTable: resd 32
global _mBsrShiftTable
_mBsrShiftTable: resb 32

section .text

global _decode
_decode:
    push ebp
    mov ebp, esp
    push esi
    push edi
    push ebx


    ; inptr
    mov esi, [ebp + 12]
    add esi, 3
    and esi, -4

    ; outptr
    mov edi, [ebp + 8]

    ; pos
    xor ecx, ecx

_decodeloop:
    mov eax, [esi]
    mov edx, [esi + 4]
    shld eax, edx, cl
    or eax, 1
    bsr edx, eax
    movzx ebx, byte [_mBsrShiftTable + edx]
    mov edx, [_mBsrLenTable + edx * 4]
    shrx eax, eax, ebx
    mov edx, [edx + eax * 4]
    add cl, dl
    rorx eax, ecx, 3
    and eax, 4
    and ecx, 0x1F
    add esi, eax
    cmp edx, 0x10000
    jae _special
    mov [edi], dh
    inc edi
    jmp _decodeloop
_exit:
    pop ebx
    pop edi
    pop esi
    pop ebp
    ret
_special:
    cmp edx, 0x12000
    jae _exit
    movzx ebx, dh
    ; ebx = [0 - 31]

    mov eax, [esi]
    mov edx, [esi + 4]
    shld eax, edx, cl
    movzx edx, byte [_shiftcount + ebx]
    shrx edx, eax, edx
    shr edx, 1
    add edx, [_lengthoffset + ebx * 4]
    ; edx = length of match
    push edx

    movzx ebx, byte [_extrabits + ebx]
    add cl, bl
    shlx eax, eax, ebx
    add cl, 5
    rorx edx, eax, 28
    shr eax, 27
    and edx, 0x7FFE0000
    movzx ebx, byte [_shiftcount_lengths + eax]
    add cl, [_extrabits_lengths + eax]
    shrx edx, edx, ebx
    add edx, [_distoffset + eax * 4]
    ; edx = distance
    neg edx

    rorx eax, ecx, 3
    and eax, 4
    and ecx, 0x1F
    add esi, eax

    mov eax, ecx ; save cl
    pop ecx      ; get length in ecx
    push esi
    lea esi, [edi + edx]
    cmp ecx, 16
    ja _specialcopy
    movdqu xmm0, [esi]
    movdqu [edi], xmm0
    add edi, ecx
    pop esi
    mov ecx, eax
    jmp _decodeloop
_specialcopy:
    rep movsb
    pop esi
    mov ecx, eax
    jmp _decodeloop

global _decode_nobmi
_decode_nobmi:
    push ebp
    mov ebp, esp
    push esi
    push edi
    push ebx


    ; inptr
    mov esi, [ebp + 12]
    add esi, 3
    and esi, -4

    ; outptr
    mov edi, [ebp + 8]

    ; pos
    xor ecx, ecx

_decodeloop_nobmi:
    mov eax, [esi]
    mov edx, [esi + 4]
    shld eax, edx, cl
    or eax, 1
    bsr edx, eax
    mov ebx, ecx
    movzx ecx, byte [_mBsrShiftTable + edx]
    mov edx, [_mBsrLenTable + edx * 4]
    shr eax, cl
    mov edx, [edx + eax * 4]
    add bl, dl
    mov eax, ebx
    and ebx, 0x1F
    shr eax, 3
    mov ecx, ebx
    and eax, 4
    add esi, eax
    cmp edx, 0x10000
    jae _special_nobmi
    mov [edi], dh
    inc edi
    jmp _decodeloop_nobmi
_special_nobmi:
    cmp edx, 0x12000
    jae _exit
    movzx ebx, dh
    ; ebx = [0 - 31]

    mov eax, [esi]
    mov edx, [esi + 4]
    shld eax, edx, cl
    push ecx
    movzx ecx, byte [_shiftcount + ebx]
    mov edx, eax
    shr eax, cl
    shr eax, 1
    add eax, [_lengthoffset + ebx * 4]
    ; eax = length of match
    
    movzx ecx, byte [_extrabits + ebx]
    pop ebx
    push eax
    add ebx, ecx
    add ebx, 5

    shl edx, cl
    mov eax, edx
    ror edx, 28
    shr eax, 27
    and edx, 0x7FFE0000

    movzx ecx, byte [_shiftcount_lengths + eax]
    add bl, [_extrabits_lengths + eax]
    shr edx, cl
    add edx, [_distoffset + eax * 4]
    neg edx
    
    mov eax, ebx
    shr eax, 3
    and ebx, 0x1F
    and eax, 4
    add esi, eax

    pop ecx      ; get length in ecx
    push esi
    lea esi, [edi + edx]
    rep movsb
    pop esi
    mov ecx, ebx
    jmp _decodeloop_nobmi